package com.hmdp.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.BooleanUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.hmdp.dto.Result;
import com.hmdp.entity.Shop;
import com.hmdp.mapper.ShopMapper;
import com.hmdp.service.IShopService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

import java.util.concurrent.TimeUnit;

import static com.hmdp.utils.RedisConstants.CACHE_SHOP_KEY;
import static com.hmdp.utils.RedisConstants.CACHE_SHOP_TTL;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author 虎哥
 * @since 2021-12-22
 */
@Service
public class ShopServiceImpl extends ServiceImpl<ShopMapper, Shop> implements IShopService {
    @Resource
    private StringRedisTemplate stringRedisTemplate;
    @Override
    public Result queryById(Long id) {
        Shop shop = queryByIdWithMutex(id);
        if (shop == null){
            return Result.fail("店铺不存在");
        }
        return Result.ok(shop);
    }

    public Shop queryByIdWithRedis(Long id) {
        // 使用redis缓存
        // 查询缓存
        String cacheShop = stringRedisTemplate.opsForValue().get(CACHE_SHOP_KEY + id);
        // 判断是否存在
        Shop shop = new Shop();
        if(StrUtil.isNotBlank(cacheShop)){
            // 存在直接返回
            shop = JSONUtil.toBean(cacheShop, Shop.class);
            return shop;
        }
        // 不存在，查询数据库
        shop = getById(id);
        if(shop == null){
            // 数据库不存在，返回错误
            return null;
            // 解决缓存穿透的话，就在这往redis存一个null
        }
        stringRedisTemplate.opsForValue().set(CACHE_SHOP_KEY + id, JSONUtil.toJsonStr(shop),CACHE_SHOP_TTL, TimeUnit.MINUTES);
        return shop;
    }

    public Shop queryByIdWithMutex(Long id) {
        String key = CACHE_SHOP_KEY + id;
        // 使用redis缓存
        // 查询缓存
        String cacheShop = stringRedisTemplate.opsForValue().get(key);
        // 判断是否存在
        Shop shop = new Shop();
        if(StrUtil.isNotBlank(cacheShop)){
            // 存在直接返回
            shop = JSONUtil.toBean(cacheShop, Shop.class);
            return shop;
        }

        boolean isLock =  false;
        try {
            isLock =tryLock(id);
            // 不存在，尝试获取互斥锁
            if(isLock){
                // 获取到互斥锁，查询数据库
                shop = getById(id);
                Thread.sleep(200); //模拟重建时的延迟
                if(shop == null){
                    // 解决缓存穿透的话，就在这往redis存一个null
                    stringRedisTemplate.opsForValue().set(key, "",CACHE_SHOP_TTL, TimeUnit.MINUTES);
                    // 数据库不存在，返回错误
                    return null;
                }
                // 存入缓存
                stringRedisTemplate.opsForValue().set(CACHE_SHOP_KEY + id, JSONUtil.toJsonStr(shop),CACHE_SHOP_TTL, TimeUnit.MINUTES);
            }
            // 没有获取到互斥锁
            // 休眠后重新执行
            Thread.sleep(50);
            return queryByIdWithMutex (id);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        } finally {
            // 释放互斥锁
            if (isLock) {
                delectLock(id);
            }
            
        }
    }

    private boolean tryLock(Long id) {
        // 本质就是设置一个redis缓存，key任意
        // 设置10秒过期时间防止死锁，10秒就够，因为这些请求一半都很快
        Boolean flag = stringRedisTemplate.opsForValue().setIfAbsent("lock:shop:"+id, "1",10, TimeUnit.SECONDS);
        return BooleanUtil.isTrue(flag);
    }
    private void delectLock(Long id) {
        // 本质就是删除上面key对应的缓存
        stringRedisTemplate.delete("lock:shop:"+id);
    }

    @Override
    @Transactional // 保证原子性
    public Result updateShopById(Shop shop) {
        Long shopId = shop.getId();
        if(shopId == null){
            return Result.fail("店铺id不能为空");
        }
        // 更新数据库
        updateById(shop);
        // 删除缓存
        stringRedisTemplate.delete(CACHE_SHOP_KEY + shopId);
        return Result.ok();
    }
}
